Unit patchconsts;

//  ////////////////////////////////////////////////////////////////////////////
//
//  Nord Modular patch file format 3.03 parser
//  Copyright (C) 2003 Marcus Andersson
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//  ////////////////////////////////////////////////////////////////////////////
//
//  Translated into Pascal by Jan Punter, meant to be compiled under Delphi 7.
//
//  Modifications CopyRight (c) 2003 Jan Punter
//
//  Distributed under the same conditions as the original code by Narcus
//  Andersson.
//
//    lupd : 2003-10-16
//
//  ////////////////////////////////////////////////////////////////////////////

Interface

Const

  // Module id codes

    M_INVALID        =   0;
    M_KEYBOARD       =   1;
    M_AUDIOIN        =   2;
    M_FOUROUTPUT     =   3;
    M_TWOOUTPUT      =   4;
    M_ONEOUTPUT      =   5;
    M_OSCA           =   7;
    M_OSCB           =   8;
    M_OSCC           =   9;
    M_OSCSLVB        =  10;
    M_OSCSLVC        =  11;
    M_OSCSLVD        =  12;
    M_OSCSLVE        =  13;
    M_OSCSLVA        =  14;
    M_NOTESEQA       =  15;
    M_PORTAMENTOB    =  16;
    M_EVENTSEQ       =  17;
    M_X_FADE         =  18;
    M_THREEMIXER     =  19;
    M_ADSR_ENV       =  20;
    M_COMPRESSOR     =  21;
    M_PARTIALGEN     =  22;
    M_MOD_ENV        =  23;
    M_LFOA           =  24;
    M_LFOB           =  25;
    M_LFOC           =  26;
    M_LFOSLVB        =  27;
    M_LFOSLVC        =  28;
    M_LFOSLVD        =  29;
    M_LFOSLVE        =  30;
    M_NOISE          =  31;
    M_FILTERBANK     =  32;
    M_CLKRNDGEN      =  33;
    M_RNDSTEPGEN     =  34;
    M_RNDPULSGEN     =  35;
    M_POSEDGEDELAY   =  36;
    M_LOGICDELAY     =  37;
    M_PULSE          =  38;
    M_SMOOTH         =  39;
    M_EIGHTMIXER     =  40;
    M_CONSTANT       =  43;
    M_GAINCONTROL    =  44;
    M_VOCALFILTER    =  45;
    M_AHD_ENV        =  46;
    M_PAN            =  47;
    M_PORTAMENTOA    =  48;
    M_FILTERD        =  49;
    M_FILTERC        =  50;
    M_FILTERE        =  51;
    M_MULTI_ENV      =  52;
    M_SAMPLEANDHOLD  =  53;
    M_QUANTIZER      =  54;
    M_INVLEVSHIFT    =  57;
    M_DRUMSYNTH      =  58;
    M_COMPARELEV     =  59;
    M_CLIP           =  61;
    M_OVERDRIVE      =  62;
    M_KEYBOARDPATCH  =  63;
    M_NEGEDGEDELAY   =  64;
    M_MIDIGLOBAL     =  65;
    M_CONTROLMIXER   =  66;
    M_NOTEDETECT     =  67;
    M_CLKGEN         =  68;
    M_CLKDIV         =  69;
    M_LOGICINV       =  70;
    M_ENVFOLLOWER    =  71;
    M_NOTESCALER     =  72;
    M_LOGICPROC      =  73;
    M_WAVEWRAP       =  74;
    M_NOTEQUANT      =  75;
    M_ONOFF          =  76;
    M_CLKDIVFIX      =  77;
    M_DELAY          =  78;
    M_FOUR_ONESWITCH =  79;
    M_LFOSLVA        =  80;
    M_AMPLIFIER      =  81;
    M_DIODE          =  82;
    M_SHAPER         =  83;
    M_AD_ENV         =  84;
    M_OSCSLVFM       =  85;
    M_FILTERA        =  86;
    M_FILTERB        =  87;
    M_ONE_FOURSWITCH =  88;
    M_COMPAREAB      =  89;
    M_NOTESEQB       =  90;
    M_CTRLSEQ        =  91;
    M_FILTERF        =  92;
    M_STEREOCHORUS   =  94;
    M_PERCOSC        =  95;
    M_FORMANTOSC     =  96;
    M_MASTEROSC      =  97;
    M_KEYQUANT       =  98;
    M_PATTERNGEN     =  99;
    M_KEYBSPLIT      = 100;
    M_PHASER         = 102;
    M_EQMID          = 103;
    M_EQSHELVING     = 104;
    M_EXPANDER       = 105;
    M_OSCSINEBANK    = 106;
    M_SPECTRALOSC    = 107;
    M_VOCODER        = 108;
    M_RANDOMGEN      = 110;
    M_LEVMULT        = 111;
    M_LEVADD         = 112;
    M_ONETOTWOFADE   = 113;
    M_TWOTOONEFADE   = 114;
    M_NOTEVELSCAL    = 115;
    M_RINGMOD        = 117;
    M_DIGITIZER      = 118;
    M_POLYAREAIN     = 127;


  // Parameter indices for every module

    P_FOUROUTPUT_LEVEL                 =  0;

    P_TWOOUTPUT_LEVEL                  =  0;
    P_TWOOUTPUT_DESTINATION            =  1;
    P_TWOOUTPUT_MUTE                   =  2;

    P_ONEOUTPUT_LEVEL                  =  0;
    P_ONEOUTPUT_DEST                   =  1;
    P_ONEOUTPUT_MUTE                   =  2;

    P_OSCA_FREQ_COARSE                 =  0;
    P_OSCA_FREQ_FINE                   =  1;
    P_OSCA_FREQ_KBT                    =  2;
    P_OSCA_PULSE_WIDTH                 =  3;
    P_OSCA_WAVEFORM                    =  4;
    P_OSCA_PITCH_MOD_1                 =  5;
    P_OSCA_PITCH_MOD_2                 =  6;
    P_OSCA_FMA_MOD                     =  7;
    P_OSCA_PW_MOD                      =  8;
    P_OSCA_MUTE                        =  9;

    P_OSCB_FREQ_COARSE                 =  0;
    P_OSCB_FREQ_FINE                   =  1;
    P_OSCB_FREQ_KBT                    =  2;
    P_OSCB_WAVEFORM                    =  3;
    P_OSCB_PITCH_MOD_1                 =  4;
    P_OSCB_PITCH_MOD_2                 =  5;
    P_OSCB_FMA_MOD                     =  6;
    P_OSCB_PWIDTH                      =  7;
    P_OSCB_MUTE                        =  8;

    P_OSCC_PITCH_COARSE                =  0;
    P_OSCC_PITCH_FINE                  =  1;
    P_OSCC_PITCH_KBT                   =  2;
    P_OSCC_PITCH_MOD_AMOUNT            =  3;
    P_OSCC_FMA                         =  4;
    P_OSCC_MUTE                        =  5;

    P_OSCSLVB_DETUNE_COARSE            =  0;
    P_OSCSLVB_DETUNE_FINE              =  1;
    P_OSCSLVB_PW                       =  2;
    P_OSCSLVB_PW_MOD                   =  3;
    P_OSCSLVB_MUTE                     =  4;

    P_OSCSLVC_DETUNE_COARSE            =  0;
    P_OSCSLVC_DETUNE_FINE              =  1;
    P_OSCSLVC_FMA_MOD                  =  2;
    P_OSCSLVC_MUTE                     =  3;

    P_OSCSLVD_DETUNE_COARSE            =  0;
    P_OSCSLVD_DETUNE_FINE              =  1;
    P_OSCSLVD_FMA_MOD                  =  2;
    P_OSCSLVD_MUTE                     =  3;

    P_OSCSLVE_DETUNE_COARSE            =  0;
    P_OSCSLVE_DETUNE_FINE              =  1;
    P_OSCSLVE_FMA_MOD                  =  2;
    P_OSCSLVE_MUTE                     =  3;

    P_OSCSLVA_DETUNE_COARSE            =  0;
    P_OSCSLVA_DETUNE_FINE              =  1;
    P_OSCSLVA_SHAPE                    =  2;
    P_OSCSLVA_FMA_MOD                  =  3;
    P_OSCSLVA_MUTE                     =  4;

    P_NOTESEQA_STEP_1                  =  0;
    P_NOTESEQA_STEP_2                  =  1;
    P_NOTESEQA_STEP_3                  =  2;
    P_NOTESEQA_STEP_4                  =  3;
    P_NOTESEQA_STEP_5                  =  4;
    P_NOTESEQA_STEP_6                  =  5;
    P_NOTESEQA_STEP_7                  =  6;
    P_NOTESEQA_STEP_8                  =  7;
    P_NOTESEQA_STEP_9                  =  8;
    P_NOTESEQA_STEP_10                 =  9;
    P_NOTESEQA_STEP_11                 = 10;
    P_NOTESEQA_STEP_12                 = 11;
    P_NOTESEQA_STEP_13                 = 12;
    P_NOTESEQA_STEP_14                 = 13;
    P_NOTESEQA_STEP_15                 = 14;
    P_NOTESEQA_STEP_16                 = 15;
    P_NOTESEQA_STEP_COUNT              = 16;
    P_NOTESEQA_EDIT_POSITION           = 17;
    P_NOTESEQA_RECORD                  = 18;
    P_NOTESEQA_PAUSE                   = 19;
    P_NOTESEQA_ACTIVE                  = 20;

    P_PORTAMENTOB_TIME                 =  0;

    P_EVENTSEQ_STEPCOUNT               =  0;
    P_EVENTSEQ_ACTIVE                  =  1;
    P_EVENTSEQ_GATE1                   =  2;
    P_EVENTSEQ_GATE2                   =  3;
    P_EVENTSEQ_SEQ_1_STEP_1            =  4;
    P_EVENTSEQ_SEQ_1_STEP_2            =  5;
    P_EVENTSEQ_SEQ_1_STEP_3            =  6;
    P_EVENTSEQ_SEQ_1_STEP_4            =  7;
    P_EVENTSEQ_SEQ_1_STEP_5            =  8;
    P_EVENTSEQ_SEQ_1_STEP_6            =  9;
    P_EVENTSEQ_SEQ_1_STEP_7            = 10;
    P_EVENTSEQ_SEQ_1_STEP_8            = 11;
    P_EVENTSEQ_SEQ_1_STEP_9            = 12;
    P_EVENTSEQ_SEQ_1_STEP_10           = 13;
    P_EVENTSEQ_SEQ_1_STEP_11           = 14;
    P_EVENTSEQ_SEQ_1_STEP_12           = 15;
    P_EVENTSEQ_SEQ_1_STEP_13           = 16;
    P_EVENTSEQ_SEQ_1_STEP_14           = 17;
    P_EVENTSEQ_SEQ_1_STEP_15           = 18;
    P_EVENTSEQ_SEQ_1_STEP_16           = 19;
    P_EVENTSEQ_SEQ_2_STEP_1            = 20;
    P_EVENTSEQ_SEQ_2_STEP_2            = 21;
    P_EVENTSEQ_SEQ_2_STEP_3            = 22;
    P_EVENTSEQ_SEQ_2_STEP_4            = 23;
    P_EVENTSEQ_SEQ_2_STEP_5            = 24;
    P_EVENTSEQ_SEQ_2_STEP_6            = 25;
    P_EVENTSEQ_SEQ_2_STEP_7            = 26;
    P_EVENTSEQ_SEQ_2_STEP_8            = 27;
    P_EVENTSEQ_SEQ_2_STEP_9            = 28;
    P_EVENTSEQ_SEQ_2_STEP_10           = 29;
    P_EVENTSEQ_SEQ_2_STEP_11           = 30;
    P_EVENTSEQ_SEQ_2_STEP_12           = 31;
    P_EVENTSEQ_SEQ_2_STEP_13           = 32;
    P_EVENTSEQ_SEQ_2_STEP_14           = 33;
    P_EVENTSEQ_SEQ_2_STEP_15           = 34;
    P_EVENTSEQ_SEQ_2_STEP_16           = 35;

    P_X_FADE_MODULATION                =  0;
    P_X_FADE_CROSSFADE                 =  1;

    P_THREEMIXER_IN_SENSE_1            =  0;
    P_THREEMIXER_IN_SENSE_2            =  1;
    P_THREEMIXER_IN_SENSE_3            =  2;

    P_ADSR_ENV_ATTACK_SHAPE            =  0;
    P_ADSR_ENV_ATTACK                  =  1;
    P_ADSR_ENV_DECAY                   =  2;
    P_ADSR_ENV_SUSTAIN                 =  3;
    P_ADSR_ENV_RELEASE                 =  4;
    P_ADSR_ENV_INVERT                  =  5;

    P_COMPRESSOR_ATTACK                =  0;
    P_COMPRESSOR_RELEASE               =  1;
    P_COMPRESSOR_TRESHOLD              =  2;
    P_COMPRESSOR_RATIO                 =  3;
    P_COMPRESSOR_REF_LEVEL             =  4;
    P_COMPRESSOR_LIMITER               =  5;
    P_COMPRESSOR_ACT                   =  6;
    P_COMPRESSOR_MON                   =  7;
    P_COMPRESSOR_BYPASS                =  8;

    P_PARTIALGEN_RANGE                 =  0;

    P_MOD_ENV_ATTACK                   =  0;
    P_MOD_ENV_DECAY                    =  1;
    P_MOD_ENV_SUSTAIN                  =  2;
    P_MOD_ENV_RELEASE                  =  3;
    P_MOD_ENV_ATTACK_MOD               =  4;
    P_MOD_ENV_DECAY_MOD                =  5;
    P_MOD_ENV_SUSTAIN_MOD              =  6;
    P_MOD_ENV_RELEASE_MOD              =  7;
    P_MOD_ENV_INVERT                   =  8;

    P_LFOA_RATE                        =  0;
    P_LFOA_RANGE                       =  1;
    P_LFOA_WAVEFORM                    =  2;
    P_LFOA_RATE_MOD                    =  3;
    P_LFOA_MONO                        =  4;
    P_LFOA_RATE_KBT                    =  5;
    P_LFOA_PHASE                       =  6;
    P_LFOA_MUTE                        =  7;

    P_LFOB_RATE                        =  0;
    P_LFOB_RANGE                       =  1;
    P_LFOB_PHASE                       =  2;
    P_LFOB_RATE_MOD                    =  3;
    P_LFOB_MONO                        =  4;
    P_LFOB_RATE_KBT                    =  5;
    P_LFOB_PW_MOD                      =  6;
    P_LFOB_PW                          =  7;

    P_LFOC_RATE                        =  0;
    P_LFOC_RANGE                       =  1;
    P_LFOC_WAVEFORM                    =  2;
    P_LFOC_RATE_MOD                    =  3;
    P_LFOC_MONO                        =  4;
    P_LFOC_MUTE                        =  5;

    P_LFOSLVB_RATE                     =  0;

    P_LFOSLVC_RATE                     =  0;

    P_LFOSLVD_RATE                     =  0;

    P_LFOSLVE_RATE                     =  0;

    P_NOISE_COLOR                      =  0;

    P_FILTERBANK_50                    =  0;
    P_FILTERBANK_75                    =  1;
    P_FILTERBANK_110                   =  2;
    P_FILTERBANK_170                   =  3;
    P_FILTERBANK_250                   =  4;
    P_FILTERBANK_380                   =  5;
    P_FILTERBANK_570                   =  6;
    P_FILTERBANK_850                   =  7;
    P_FILTERBANK_1_3                   =  8;
    P_FILTERBANK_1_9                   =  9;
    P_FILTERBANK_2_9                   = 10;
    P_FILTERBANK_4_2                   = 11;
    P_FILTERBANK_6_4                   = 12;
    P_FILTERBANK_8_3                   = 13;
    P_FILTERBANK_BYPASS                = 14;

    P_CLKRNDGEN_MONO                   =  0;
    P_CLKRNDGEN_COL                    =  1;

    P_RNDSTEPGEN_RATE                  =  0;

    P_RNDPULSGEN_DENSITY               =  0;

    P_POSEDGEDELAY_TIME                =  0;

    P_LOGICDELAY_TIME                  =  0;

    P_PULSE_TIME                       =  0;

    P_SMOOTH_TIME                      =  0;

    P_EIGHTMIXER_IN_SENSE_1            =  0;
    P_EIGHTMIXER_IN_SENSE_2            =  1;
    P_EIGHTMIXER_IN_SENSE_3            =  2;
    P_EIGHTMIXER_IN_SENSE_4            =  3;
    P_EIGHTMIXER_IN_SENSE_5            =  4;
    P_EIGHTMIXER_IN_SENSE_6            =  5;
    P_EIGHTMIXER_IN_SENSE_7            =  6;
    P_EIGHTMIXER_IN_SENSE_8            =  7;
    P_EIGHTMIXER__6DB                  =  8;

    P_CONSTANT_VALUE                   =  0;
    P_CONSTANT_UNIPOLAR                =  1;

    P_GAINCONTROL_SHIFT                =  0;

    P_VOCALFILTER_LEFT_VOWEL           =  0;
    P_VOCALFILTER_MIDDLE_VOWEL         =  1;
    P_VOCALFILTER_RIGHT_VOWEL          =  2;
    P_VOCALFILTER_IN_AMPLIFICATION     =  3;
    P_VOCALFILTER_VOWEL_SELECT         =  4;
    P_VOCALFILTER_VOWEL_SELECT_MOD     =  5;
    P_VOCALFILTER_FREQUENCY            =  6;
    P_VOCALFILTER_FREQUENCY_MOD        =  7;
    P_VOCALFILTER_RESONANCE            =  8;

    P_AHD_ENV_A                        =  0;
    P_AHD_ENV_H                        =  1;
    P_AHD_ENV_D                        =  2;
    P_AHD_ENV_A_MOD                    =  3;
    P_AHD_ENV_H_MOD                    =  4;
    P_AHD_ENV_D_MOD                    =  5;

    P_PAN_PAN_MOD                      =  0;
    P_PAN_PAN                          =  1;

    P_PORTAMENTOA_TIME                 =  0;

    P_FILTERD_FREQ                     =  0;
    P_FILTERD_KBT                      =  1;
    P_FILTERD_RESONANCE                =  2;
    P_FILTERD_FREQMOD                  =  3;

    P_FILTERC_FREQ                     =  0;
    P_FILTERC_RESONANCE                =  1;
    P_FILTERC_GAIN_CONTROL             =  2;

    P_FILTERE_FILTER_TYPE              =  0;
    P_FILTERE_GAIN_CONTROL             =  1;
    P_FILTERE_FREQUENCY_MOD_1          =  2;
    P_FILTERE_FREQUENCY                =  3;
    P_FILTERE_KBT                      =  4;
    P_FILTERE_RESONANCE_MOD            =  5;
    P_FILTERE_RESONANCE                =  6;
    P_FILTERE_SLOPE                    =  7;
    P_FILTERE_FREQUENCY_MOD_2          =  8;
    P_FILTERE_BYPASS                   =  9;

    P_MULTI_ENV_LEVEL_1                =  0;
    P_MULTI_ENV_LEVEL_2                =  1;
    P_MULTI_ENV_LEVEL_3                =  2;
    P_MULTI_ENV_LEVEL_4                =  3;
    P_MULTI_ENV_TIME_1                 =  4;
    P_MULTI_ENV_TIME_2                 =  5;
    P_MULTI_ENV_TIME_3                 =  6;
    P_MULTI_ENV_TIME_4                 =  7;
    P_MULTI_ENV_TIME_5                 =  8;
    P_MULTI_ENV_SUSTAIN                =  9;
    P_MULTI_ENV_CURVE                  = 10;

    P_QUANTIZER_BITS                   =  0;

    P_INVLEVSHIFT_MODE                 =  0;
    P_INVLEVSHIFT_INV                  =  1;

    P_DRUMSYNTH_MTUNE                  =  0;
    P_DRUMSYNTH_STUNE                  =  1;
    P_DRUMSYNTH_MDECAY                 =  2;
    P_DRUMSYNTH_SDECAY                 =  3;
    P_DRUMSYNTH_MLEVEL                 =  4;
    P_DRUMSYNTH_SLEVEL                 =  5;
    P_DRUMSYNTH_FILTER_FREQ            =  6;
    P_DRUMSYNTH_FILTER_RES             =  7;
    P_DRUMSYNTH_FILTER_SWEEP           =  8;
    P_DRUMSYNTH_FILTER_DECAY           =  9;
    P_DRUMSYNTH_FILTER_MODE            = 10;
    P_DRUMSYNTH_AMOUNT                 = 11;
    P_DRUMSYNTH_DECAY                  = 12;
    P_DRUMSYNTH_CLICK                  = 13;
    P_DRUMSYNTH_NOISE                  = 14;
    P_DRUMSYNTH_MUTE                   = 15;

    P_COMPARELEV_LEVEL                 =  0;

    P_CLIP_CLIP_MOD                    =  0;
    P_CLIP_CLIP                        =  1;
    P_CLIP_SYM                         =  2;

    P_OVERDRIVE_OVERDRIVE_MOD          =  0;
    P_OVERDRIVE_OVERDRIVE              =  1;

    P_NEGEDGEDELAY_TIME                =  0;

    P_CONTROLMIXER_INV_1               =  0;
    P_CONTROLMIXER_LEVEL_1             =  1;
    P_CONTROLMIXER_INV_2               =  2;
    P_CONTROLMIXER_LEVEL_2             =  3;
    P_CONTROLMIXER_MODE                =  4;

    P_NOTEDETECT_NOTE                  =  0;

    P_CLKGEN_RATE                      =  0;
    P_CLKGEN_ON_OFF                    =  1;

    P_CLKDIV_DIVIDER                   =  0;

    P_ENVFOLLOWER_ATTACK               =  0;
    P_ENVFOLLOWER_RELEASE              =  1;

    P_NOTESCALER_TRANSPOSE             =  0;

    P_LOGICPROC_MODE                   =  0;

    P_WAVEWRAP_WRAP_MOD                =  0;
    P_WAVEWRAP_WRAP                    =  1;

    P_NOTEQUANT_RANGE                  =  0;
    P_NOTEQUANT_NOTES                  =  1;

    P_ONOFF_ON_OFF                     =  0;

    P_DELAY_MODULATION                 =  0;
    P_DELAY_TIME                       =  1;

    P_FOUR_ONESWITCH_IN                =  0;
    P_FOUR_ONESWITCH_LEVEL_1           =  1;
    P_FOUR_ONESWITCH_LEVEL_2           =  2;
    P_FOUR_ONESWITCH_LEVEL_3           =  3;
    P_FOUR_ONESWITCH_LEVEL_4           =  4;
    P_FOUR_ONESWITCH_MUTE              =  5;

    P_LFOSLVA_RATE                     =  0;
    P_LFOSLVA_PHASE                    =  1;
    P_LFOSLVA_WAVEFORM                 =  2;
    P_LFOSLVA_MONO                     =  3;
    P_LFOSLVA_MUTE                     =  4;

    P_AMPLIFIER_GAIN                   =  0;

    P_DIODE_MODE                       =  0;

    P_SHAPER_MODE                      =  0;

    P_AD_ENV_ATTACK                    =  0;
    P_AD_ENV_DECAY                     =  1;
    P_AD_ENV_GATE                      =  2;

    P_OSCSLVFM_DETUNE                  =  0;
    P_OSCSLVFM_FINE                    =  1;
    P_OSCSLVFM__3OCT                   =  2;
    P_OSCSLVFM_FMB                     =  3;
    P_OSCSLVFM_MUTE                    =  4;

    P_FILTERA_FREQUENCY                =  0;

    P_FILTERB_FREQUENCY                =  0;

    P_ONE_FOURSWITCH_IN                =  0;
    P_ONE_FOURSWITCH_LEVEL             =  1;
    P_ONE_FOURSWITCH_MUTE              =  2;

    P_NOTESEQB_NOTE_1                  =  0;
    P_NOTESEQB_NOTE_2                  =  1;
    P_NOTESEQB_NOTE_3                  =  2;
    P_NOTESEQB_NOTE_4                  =  3;
    P_NOTESEQB_NOTE_5                  =  4;
    P_NOTESEQB_NOTE_6                  =  5;
    P_NOTESEQB_NOTE_7                  =  6;
    P_NOTESEQB_NOTE_8                  =  7;
    P_NOTESEQB_NOTE_9                  =  8;
    P_NOTESEQB_NOTE_10                 =  9;
    P_NOTESEQB_NOTE_11                 = 10;
    P_NOTESEQB_NOTE_12                 = 11;
    P_NOTESEQB_NOTE_13                 = 12;
    P_NOTESEQB_NOTE_14                 = 13;
    P_NOTESEQB_NOTE_15                 = 14;
    P_NOTESEQB_NOTE_16                 = 15;
    P_NOTESEQB_STEP                    = 16;
    P_NOTESEQB_CURRENTSTEP             = 17;
    P_NOTESEQB_RECORD                  = 18;
    P_NOTESEQB_PLAY                    = 19;
    P_NOTESEQB_LOOP                    = 20;

    P_CTRLSEQ_CTRL_1                   =  0;
    P_CTRLSEQ_CTRL_2                   =  1;
    P_CTRLSEQ_CTRL_3                   =  2;
    P_CTRLSEQ_CTRL_4                   =  3;
    P_CTRLSEQ_CTRL_5                   =  4;
    P_CTRLSEQ_CTRL_6                   =  5;
    P_CTRLSEQ_CTRL_7                   =  6;
    P_CTRLSEQ_CTRL_8                   =  7;
    P_CTRLSEQ_CTRL_9                   =  8;
    P_CTRLSEQ_CTRL_10                  =  9;
    P_CTRLSEQ_CTRL_11                  = 10;
    P_CTRLSEQ_CTRL_12                  = 11;
    P_CTRLSEQ_CTRL_13                  = 12;
    P_CTRLSEQ_CTRL_14                  = 13;
    P_CTRLSEQ_CTRL_15                  = 14;
    P_CTRLSEQ_CTRL_16                  = 15;
    P_CTRLSEQ_STEP                     = 16;
    P_CTRLSEQ_UNI                      = 17;
    P_CTRLSEQ_LOOP                     = 18;

    P_FILTERF_FREQUENCY                =  0;
    P_FILTERF_KBT                      =  1;
    P_FILTERF_RESONANCE                =  2;
    P_FILTERF_FREQ_MOD_1               =  3;
    P_FILTERF_FREQ_MOD_2               =  4;
    P_FILTERF_SLOPE                    =  5;
    P_FILTERF_BYPASS                   =  6;

    P_STEREOCHORUS_DETUNE              =  0;
    P_STEREOCHORUS_AMOUNT              =  1;
    P_STEREOCHORUS_BYPASS              =  2;

    P_PERCOSC_PITCH                    =  0;
    P_PERCOSC_CLICK                    =  1;
    P_PERCOSC_DECAY                    =  2;
    P_PERCOSC_PUNCH                    =  3;
    P_PERCOSC_PITCHMOD                 =  4;
    P_PERCOSC_PITCHFINE                =  5;
    P_PERCOSC_MUTE                     =  6;

    P_FORMANTOSC_PITCH                 =  0;
    P_FORMANTOSC_PITCH_FINE            =  1;
    P_FORMANTOSC_KBT                   =  2;
    P_FORMANTOSC_MUTE                  =  3;
    P_FORMANTOSC_TIMBRE                =  4;
    P_FORMANTOSC_PITCH_MOD_1           =  5;
    P_FORMANTOSC_PITCH_MOD_2           =  6;

    P_MASTEROSC_PITCH                  =  0;
    P_MASTEROSC_PITCH_FINE             =  1;
    P_MASTEROSC_KBT                    =  2;
    P_MASTEROSC_PITCH_MOD_1            =  3;
    P_MASTEROSC_PITCH_MOD_2            =  4;

    P_KEYQUANT_RANGE                   =  0;
    P_KEYQUANT_CONT                    =  1;
    P_KEYQUANT_E                       =  2;
    P_KEYQUANT_F                       =  3;
    P_KEYQUANT_FSHARP                  =  4;
    P_KEYQUANT_G                       =  5;
    P_KEYQUANT_GSHARP                  =  6;
    P_KEYQUANT_A                       =  7;
    P_KEYQUANT_BB                      =  8;
    P_KEYQUANT_B                       =  9;
    P_KEYQUANT_C                       = 10;
    P_KEYQUANT_CSHARP                  = 11;
    P_KEYQUANT_D                       = 12;
    P_KEYQUANT_DSHARP                  = 13;

    P_PATTERNGEN_PATTERN               =  0;
    P_PATTERNGEN_BANK                  =  1;
    P_PATTERNGEN_LOW_DELTA             =  2;
    P_PATTERNGEN_STEP                  =  3;
    P_PATTERNGEN_MONO                  =  4;

    P_KEYBSPLIT_LOWER                  =  0;
    P_KEYBSPLIT_UPPER                  =  1;

    P_PHASER_RATE                      =  0;
    P_PHASER_LFO                       =  1;
    P_PHASER_CENTER_FREQ_MOD           =  2;
    P_PHASER_CENTER_FREQ               =  3;
    P_PHASER_SPREAD_MOD                =  4;
    P_PHASER_FEEDBACK                  =  5;
    P_PHASER_PEAKS                     =  6;
    P_PHASER_SPREAD                    =  7;
    P_PHASER_BYPASS                    =  8;
    P_PHASER_DEPTH                     =  9;
    P_PHASER_INLEVEL                   = 10;

    P_EQMID_FREQ                       =  0;
    P_EQMID_GAIN                       =  1;
    P_EQMID_BANDWIDTH                  =  2;
    P_EQMID_BYPASS                     =  3;
    P_EQMID_IN_LEVEL                   =  4;

    P_EQSHELVING_FREQ                  =  0;
    P_EQSHELVING_GAIN                  =  1;
    P_EQSHELVING_MODE                  =  2;
    P_EQSHELVING_BYPASS                =  3;
    P_EQSHELVING_IN_LEVEL              =  4;

    P_EXPANDER_ATTACK                  =  0;
    P_EXPANDER_RELEASE                 =  1;
    P_EXPANDER_TRESHOLD                =  2;
    P_EXPANDER_RATIO                   =  3;
    P_EXPANDER_GATE                    =  4;
    P_EXPANDER_HOLD                    =  5;
    P_EXPANDER_SIDECHAIN_ACTIVATION    =  6;
    P_EXPANDER_SIDECHAIN_MONITOR       =  7;
    P_EXPANDER_BYPASS                  =  8;

    P_OSCSINEBANK_OSC1_COARSE          =  0;
    P_OSCSINEBANK_OSC1_FINE            =  1;
    P_OSCSINEBANK_OSC1_LEVEL           =  2;
    P_OSCSINEBANK_OSC2_COARSE          =  3;
    P_OSCSINEBANK_OSC2_FINE            =  4;
    P_OSCSINEBANK_OSC2_LEVEL           =  5;
    P_OSCSINEBANK_OSC3_COARSE          =  6;
    P_OSCSINEBANK_OSC3_FINE            =  7;
    P_OSCSINEBANK_OSC3_LEVEL           =  8;
    P_OSCSINEBANK_OSC4_COARSE          =  9;
    P_OSCSINEBANK_OSC4_FINE            = 10;
    P_OSCSINEBANK_OSC4_LEVEL           = 11;
    P_OSCSINEBANK_OSC5_COARSE          = 12;
    P_OSCSINEBANK_OSC5_FINE            = 13;
    P_OSCSINEBANK_OSC5_LEVEL           = 14;
    P_OSCSINEBANK_OSC6_COARSE          = 15;
    P_OSCSINEBANK_OSC6_FINE            = 16;
    P_OSCSINEBANK_OSC6_LEVEL           = 17;
    P_OSCSINEBANK_OSC1_MUTE            = 18;
    P_OSCSINEBANK_OSC2_MUTE            = 19;
    P_OSCSINEBANK_OSC3_MUTE            = 20;
    P_OSCSINEBANK_OSC4_MUTE            = 21;
    P_OSCSINEBANK_OSC5_MUTE            = 22;
    P_OSCSINEBANK_OSC6_MUTE            = 23;

    P_SPECTRALOSC_FREQ_COARSE          =  0;
    P_SPECTRALOSC_FREQ_FINE            =  1;
    P_SPECTRALOSC_SPECTRAL_SHAPE       =  2;
    P_SPECTRALOSC_PARTIALS             =  3;
    P_SPECTRALOSC_PITCH_MOD_1          =  4;
    P_SPECTRALOSC_PITCH_MOD_2          =  5;
    P_SPECTRALOSC_FMA                  =  6;
    P_SPECTRALOSC_SPECTRAL_SHAPE_MOD   =  7;
    P_SPECTRALOSC_KBT                  =  8;
    P_SPECTRALOSC_MUTE                 =  9;

    P_VOCODER_BAND_1                   =  0;
    P_VOCODER_BAND_2                   =  1;
    P_VOCODER_BAND_3                   =  2;
    P_VOCODER_BAND_4                   =  3;
    P_VOCODER_BAND_5                   =  4;
    P_VOCODER_BAND_6                   =  5;
    P_VOCODER_BAND_7                   =  6;
    P_VOCODER_BAND_8                   =  7;
    P_VOCODER_BAND_9                   =  8;
    P_VOCODER_BAND_10                  =  9;
    P_VOCODER_BAND_11                  = 10;
    P_VOCODER_BAND_12                  = 11;
    P_VOCODER_BAND_13                  = 12;
    P_VOCODER_BAND_14                  = 13;
    P_VOCODER_BAND_15                  = 14;
    P_VOCODER_BAND_16                  = 15;
    P_VOCODER_OUTGAIN                  = 16;
    P_VOCODER_HIGH_FREQ_EMPHASIS       = 17;
    P_VOCODER_MONITOR                  = 18;

    P_RANDOMGEN_RATE                   =  0;

    P_LEVMULT_MULTIPLIER               =  0;
    P_LEVMULT_UNIPOLAR                 =  1;

    P_LEVADD_OFFSET                    =  0;
    P_LEVADD_UNIPOLAR                  =  1;

    P_ONETOTWOFADE_FADE                =  0;

    P_TWOTOONEFADE_FADE                =  0;

    P_NOTEVELSCAL_VELOCITY_SENSITIVITY =  0;
    P_NOTEVELSCAL_LEFT_GAIN            =  1;
    P_NOTEVELSCAL_BREAKPOINT           =  2;
    P_NOTEVELSCAL_RIGHT_GAIN           =  3;

    P_RINGMOD_RINGMOD_DEPTH_MOD        =  0;
    P_RINGMOD_RINGMOD_DEPTH            =  1;

    P_DIGITIZER_QUANT_BITS             =  0;
    P_DIGITIZER_SAMPLE_RATE            =  1;
    P_DIGITIZER_SAMPLE_RATE_MOD        =  2;
    P_DIGITIZER_QUANT_OFF              =  3;
    P_DIGITIZER_SAMPLING_OFF           =  4;

    P_POLYAREAIN_PLUS6DB               =  0;


  // Input indices for every module

    I_OSCA_SYNC                        = 0;
    I_OSCA_FMA                         = 1;
    I_OSCA_PITCH_1                     = 2;
    I_OSCA_PITCH_2                     = 3;
    I_OSCA_PULSE_WIDTH_MOD             = 4;

    I_OSCB_FMA                         = 0;
    I_OSCB_PITCH_1                     = 1;
    I_OSCB_PITCH_2                     = 2;
    I_OSCB_PW_MOD                      = 3;

    I_OSCC_FMA                         = 0;
    I_OSCC_PITCH                       = 1;
    I_OSCC_AM                          = 2;

    I_OSCSLVB_MST                      = 0;
    I_OSCSLVB_PWMOD                    = 1;

    I_OSCSLVC_MST                      = 0;
    I_OSCSLVC_FMA                      = 1;

    I_OSCSLVD_MST                      = 0;
    I_OSCSLVD_FMA                      = 1;

    I_OSCSLVE_MST                      = 0;
    I_OSCSLVE_FMA                      = 1;
    I_OSCSLVE_AM                       = 2;

    I_OSCSLVA_MST                      = 0;
    I_OSCSLVA_FMA                      = 1;
    I_OSCSLVA_SYNC                     = 2;
    I_OSCSLVA_AM                       = 3;

    I_NOTESEQA_SYNC                    = 0;
    I_NOTESEQA_RESET                   = 1;

    I_PORTAMENTOB_IN                   = 0;
    I_PORTAMENTOB_JMP                  = 1;

    I_EVENTSEQ_CLOCK                   = 0;
    I_EVENTSEQ_RESET                   = 1;

    I_X_FADE_IN1                       = 0;
    I_X_FADE_IN2                       = 1;
    I_X_FADE_MODULATION                = 2;

    I_THREEMIXER_IN1                   = 0;
    I_THREEMIXER_IN2                   = 1;
    I_THREEMIXER_IN3                   = 2;

    I_ADSR_ENV_IN                      = 0;
    I_ADSR_ENV_GATE                    = 1;
    I_ADSR_ENV_RETRIG                  = 2;
    I_ADSR_ENV_AMP                     = 3;

    I_COMPRESSOR_LEFT                  = 0;
    I_COMPRESSOR_RIGHT                 = 1;
    I_COMPRESSOR_SIDE                  = 2;

    I_PARTIALGEN_IN                    = 0;

    I_MOD_ENV_GATE                     = 0;
    I_MOD_ENV_RETRIG                   = 1;
    I_MOD_ENV_ATTACK_MOD               = 2;
    I_MOD_ENV_DECAY_MOD                = 3;
    I_MOD_ENV_SUSTAIN_MOD              = 4;
    I_MOD_ENV_RELEASE_MOD              = 5;
    I_MOD_ENV_IN                       = 6;
    I_MOD_ENV_AMP                      = 7;

    I_LFOA_RATE                        = 0;
    I_LFOA_RESET                       = 1;

    I_LFOB_RATE                        = 0;
    I_LFOB_RST                         = 1;
    I_LFOB_PWMOD                       = 2;

    I_LFOC_RATE                        = 0;

    I_LFOSLVB_MST                      = 0;

    I_LFOSLVC_MST                      = 0;

    I_LFOSLVD_MST                      = 0;

    I_LFOSLVE_MST                      = 0;

    I_FILTERBANK_IN                    = 0;

    I_CLKRNDGEN_CLK                    = 0;

    I_RNDSTEPGEN_MST                   = 0;

    I_POSEDGEDELAY_IN                  = 0;

    I_LOGICDELAY_IN                    = 0;

    I_PULSE_IN                         = 0;

    I_SMOOTH_IN                        = 0;

    I_EIGHTMIXER_IN_1                  = 0;
    I_EIGHTMIXER_IN_2                  = 1;
    I_EIGHTMIXER_IN_3                  = 2;
    I_EIGHTMIXER_IN_4                  = 3;
    I_EIGHTMIXER_IN_5                  = 4;
    I_EIGHTMIXER_IN_6                  = 5;
    I_EIGHTMIXER_IN_7                  = 6;
    I_EIGHTMIXER_IN_8                  = 7;

    I_GAINCONTROL_CONTROL              = 0;
    I_GAINCONTROL_IN                   = 1;

    I_VOCALFILTER_IN                   = 0;
    I_VOCALFILTER_VOWEL_SELECT_MOD     = 1;
    I_VOCALFILTER_FREQUENCY_MOD        = 2;

    I_AHD_ENV_TRIG                     = 0;
    I_AHD_ENV_A_MOD                    = 1;
    I_AHD_ENV_H_MOD                    = 2;
    I_AHD_ENV_D_MOD                    = 3;
    I_AHD_ENV_IN                       = 4;
    I_AHD_ENV_AMP                      = 5;

    I_PAN_IN                           = 0;
    I_PAN_PANMOD                       = 1;

    I_PORTAMENTOA_IN                   = 0;
    I_PORTAMENTOA_ON                   = 1;

    I_FILTERD_FREQ_MOD                 = 0;
    I_FILTERD_IN                       = 1;

    I_FILTERC_IN = 0;

    I_FILTERE_FREQ_MOD_1               = 0;
    I_FILTERE_RES_MOD                  = 1;
    I_FILTERE_IN                       = 2;
    I_FILTERE_FREQ_MOD_2               = 3;

    I_MULTI_ENV_GATE                   = 0;
    I_MULTI_ENV_IN                     = 1;
    I_MULTI_ENV_AMP                    = 2;

    I_SAMPLEANDHOLD_TRIG               = 0;
    I_SAMPLEANDHOLD_IN                 = 1;

    I_QUANTIZER_IN                     = 0;

    I_INVLEVSHIFT_IN                   = 0;

    I_DRUMSYNTH_TRIG                   = 0;
    I_DRUMSYNTH_VEL                    = 1;
    I_DRUMSYNTH_PITCH                  = 2;

    I_COMPARELEV_IN                    = 0;

    I_CLIP_IN                          = 0;
    I_CLIP_CLIP                        = 1;

    I_OVERDRIVE_OVERDRIVE_MOD          = 0;
    I_OVERDRIVE_IN                     = 1;

    I_NEGEDGEDELAY_IN                  = 0;

    I_CONTROLMIXER_IN1                 = 0;
    I_CONTROLMIXER_IN2                 = 1;

    I_CLKGEN_RESET                     = 0;

    I_CLKDIV_CLOCK                     = 0;
    I_CLKDIV_RESET                     = 1;

    I_LOGICINV_IN                      = 0;

    I_ENVFOLLOWER_IN                   = 0;

    I_NOTESCALER_IN                    = 0;

    I_LOGICPROC_IN1                    = 0;
    I_LOGICPROC_IN2                    = 1;

    I_WAVEWRAP_IN                      = 0;
    I_WAVEWRAP_WRAP_MOD                = 1;

    I_NOTEQUANT_IN                     = 0;

    I_ONOFF_IN                         = 0;

    I_CLKDIVFIX_RESET                  = 0;
    I_CLKDIVFIX_MIDICLOCK              = 1;

    I_DELAY_IN                         = 0;
    I_DELAY_MODULATION                 = 1;

    I_FOUR_ONESWITCH_IN_1              = 0;
    I_FOUR_ONESWITCH_IN_2              = 1;
    I_FOUR_ONESWITCH_IN_3              = 2;
    I_FOUR_ONESWITCH_IN_4              = 3;

    I_LFOSLVA_MASTER                   = 0;
    I_LFOSLVA_RESET                    = 1;

    I_AMPLIFIER_IN                     = 0;

    I_DIODE_IN                         = 0;

    I_SHAPER_IN                        = 0;

    I_AD_ENV_TRIGGER                   = 0;
    I_AD_ENV_IN                        = 1;
    I_AD_ENV_AMP                       = 2;

    I_OSCSLVFM_MASTER                  = 0;
    I_OSCSLVFM_FMB                     = 1;
    I_OSCSLVFM_SYNC                    = 2;

    I_FILTERA_IN                       = 0;

    I_FILTERB_IN                       = 0;

    I_ONE_FOURSWITCH_IN                = 0;

    I_COMPAREAB_A                      = 0;
    I_COMPAREAB_B                      = 1;

    I_NOTESEQB_CLOCK                   = 0;
    I_NOTESEQB_RESET                   = 1;

    I_CTRLSEQ_CLOCK                    = 0;
    I_CTRLSEQ_RESET                    = 1;

    I_FILTERF_FREQ_MOD_1               = 0;
    I_FILTERF_FREQ_MOD_2               = 1;
    I_FILTERF_IN                       = 2;

    I_STEREOCHORUS_IN                  = 0;

    I_PERCOSC_TRIG                     = 0;
    I_PERCOSC_AMP                      = 1;
    I_PERCOSC_PITCHMOD                 = 2;

    I_FORMANTOSC_PITCH_MOD_1           = 0;
    I_FORMANTOSC_PITCH_MOD_2           = 1;
    I_FORMANTOSC_TIMBRE                = 2;

    I_MASTEROSC_PITCH_MOD_1            = 0;
    I_MASTEROSC_PITCH_MOD_2            = 1;

    I_KEYQUANT_IN                      = 0;

    I_PATTERNGEN_CLOCK                 = 0;
    I_PATTERNGEN_RESET                 = 1;
    I_PATTERNGEN_PATTERN_AND_BANK      = 2;

    I_KEYBSPLIT_NOTE                   = 0;
    I_KEYBSPLIT_GATE                   = 1;
    I_KEYBSPLIT_VEL                    = 2;

    I_PHASER_IN                        = 0;
    I_PHASER_CENTER_FREQ_MOD           = 1;
    I_PHASER_SPREAD_MOD                = 2;

    I_EQMID_IN                         = 0;

    I_EQSHELVING_IN                    = 0;

    I_EXPANDER_IN_LEFT                 = 0;
    I_EXPANDER_IN_RIGHT                = 1;
    I_EXPANDER_SIDECHAIN               = 2;

    I_OSCSINEBANK_MASTER               = 0;
    I_OSCSINEBANK_MIXIN                = 1;
    I_OSCSINEBANK_SYNC                 = 2;
    I_OSCSINEBANK_OSC1_AM              = 3;
    I_OSCSINEBANK_OSC2_AM              = 4;
    I_OSCSINEBANK_OSC3_AM              = 5;
    I_OSCSINEBANK_OSC4_AM              = 6;
    I_OSCSINEBANK_OSC5_AM              = 7;
    I_OSCSINEBANK_OSC6_AM              = 8;

    I_SPECTRALOSC_FMA                  = 0;
    I_SPECTRALOSC_PITCH_MOD_1          = 1;
    I_SPECTRALOSC_PITCH_MOD_2          = 2;
    I_SPECTRALOSC_SPECTRAL_SHAPE_MOD   = 3;

    I_VOCODER_CONTROL                  = 0;
    I_VOCODER_IN                       = 1;

    I_RANDOMGEN_MASTER                 = 0;

    I_LEVMULT_IN                       = 0;

    I_LEVADD_IN                        = 0;

    I_ONETOTWOFADE_IN                  = 0;

    I_TWOTOONEFADE_IN_1                = 0;
    I_TWOTOONEFADE_IN_2                = 1;

    I_NOTEVELSCAL_VELOCITY             = 0;
    I_NOTEVELSCAL_NOTE                 = 1;

    I_RINGMOD_IN                       = 0;
    I_RINGMOD_MODULATION               = 1;
    I_RINGMOD_MODULATIONDEPTH          = 2;

    I_DIGITIZER_IN                     = 0;
    I_DIGITIZER_SAMPLE_RATE_MOD        = 1;


  // output indices for every module

    O_KEYBOARD_NOTE                    = 0;
    O_KEYBOARD_GATE                    = 1;
    O_KEYBOARD_VELOCITY_ON             = 2;
    O_KEYBOARD_VELOCITY_OFF            = 3;

    O_AUDIOIN_LEFT                     = 0;
    O_AUDIOIN_RIGHT                    = 1;

    O_FOUROUTPUT_OUT_1                 = 0;
    O_FOUROUTPUT_OUT_2                 = 1;
    O_FOUROUTPUT_OUT_3                 = 2;
    O_FOUROUTPUT_OUT_4                 = 3;

    O_TWOOUTPUT_OUT_LEFT               = 0;
    O_TWOOUTPUT_OUT_RIGHT              = 1;

    O_ONEOUTPUT_OUT                    = 0;

    O_OSCA_OUT                         = 0;
    O_OSCA_SLV                         = 1;

    O_OSCB_OUT                         = 0;
    O_OSCB_SLV                         = 1;

    O_OSCC_OUT                         = 0;
    O_OSCC_SLV                         = 1;

    O_OSCSLVB_OUT                      = 0;

    O_OSCSLVC_OUT                      = 0;

    O_OSCSLVD_OUT                      = 0;

    O_OSCSLVE_OUT                      = 0;

    O_OSCSLVA_OUT                      = 0;

    O_NOTESEQA_OUT                     = 0;
    O_NOTESEQA_SYNC                    = 1;
    O_NOTESEQA_LINK                    = 2;
    O_NOTESEQA_GCLK                    = 3;

    O_PORTAMENTOB_OUT                  = 0;

    O_EVENTSEQ_OUT1                    = 0;
    O_EVENTSEQ_OUT2                    = 1;
    O_EVENTSEQ_SYNC                    = 2;
    O_EVENTSEQ_LINK                    = 3;

    O_X_FADE_OUT                       = 0;

    O_THREEMIXER_OUT                   = 0;

    O_ADSR_ENV_ENV                     = 0;
    O_ADSR_ENV_OUT                     = 1;

    O_COMPRESSOR_LEFT                  = 0;
    O_COMPRESSOR_RIGHT                 = 1;

    O_PARTIALGEN_OUT                   = 0;

    O_MOD_ENV_ENV                      = 0;
    O_MOD_ENV_OUT                      = 1;

    O_LFOA_SLV                         = 0;
    O_LFOA_OUT                         = 1;

    O_LFOB_OUT                         = 0;
    O_LFOB_SLV                         = 1;

    O_LFOC_OUT                         = 0;
    O_LFOC_SLV                         = 1;

    O_LFOSLVB_OUT                      = 0;

    O_LFOSLVC_OUT                      = 0;

    O_LFOSLVD_OUT                      = 0;

    O_LFOSLVE_OUT                      = 0;

    O_NOISE_OUT                        = 0;

    O_FILTERBANK_OUT                   = 0;

    O_CLKRNDGEN_OUT                    = 0;

    O_RNDSTEPGEN_OUT                   = 0;

    O_RNDPULSGEN_OUT                   = 0;

    O_POSEDGEDELAY_OUT                 = 0;

    O_LOGICDELAY_OUT                   = 0;

    O_PULSE_OUT                        = 0;

    O_SMOOTH_OUT                       = 0;

    O_EIGHTMIXER_OUT                   = 0;

    O_CONSTANT_OUT                     = 0;

    O_GAINCONTROL_OUT                  = 0;

    O_VOCALFILTER_OUT                  = 0;

    O_AHD_ENV_ENV                      = 0;
    O_AHD_ENV_OUT                      = 1;

    O_PAN_OUTL                         = 0;
    O_PAN_OUTR                         = 1;

    O_PORTAMENTOA_OUT                  = 0;

    O_FILTERD_HP                       = 0;
    O_FILTERD_BP                       = 1;
    O_FILTERD_LP                       = 2;

    O_FILTERC_LP                       = 0;
    O_FILTERC_BP                       = 1;
    O_FILTERC_HP                       = 2;

    O_FILTERE_OUT                      = 0;

    O_MULTI_ENV_ENV                    = 0;
    O_MULTI_ENV_OUT                    = 1;

    O_SAMPLEANDHOLD_OUT                = 0;

    O_QUANTIZER_OUT                    = 0;

    O_INVLEVSHIFT_OUT                  = 0;

    O_DRUMSYNTH_OUT                    = 0;

    O_COMPARELEV_OUT                   = 0;

    O_CLIP_OUT                         = 0;

    O_OVERDRIVE_OUT                    = 0;

    O_KEYBOARDPATCH_LATEST_NOTE        = 0;
    O_KEYBOARDPATCH_PATCH_GATE         = 1;
    O_KEYBOARDPATCH_LATEST_VEL_ON      = 2;
    O_KEYBOARDPATCH_LATEST_REL_VEL     = 3;

    O_NEGEDGEDELAY_OUT                 = 0;

    O_MIDIGLOBAL_CLOCK                 = 0;
    O_MIDIGLOBAL_SYNC                  = 1;
    O_MIDIGLOBAL_ACTIVE                = 2;

    O_CONTROLMIXER_OUT                 = 0;

    O_NOTEDETECT_GATE                  = 0;
    O_NOTEDETECT_VELOCITY              = 1;
    O_NOTEDETECT_RELEASEVELOCITY       = 2;

    O_CLKGEN_24_PULSES___BEAT          = 0;
    O_CLKGEN_4_PULSES___BEAT           = 1;
    O_CLKGEN_SLV                       = 2;
    O_CLKGEN_SYNC                      = 3;

    O_CLKDIV_OUT                       = 0;

    O_LOGICINV_OUT                     = 0;

    O_ENVFOLLOWER_OUT                  = 0;

    O_NOTESCALER_OUT                   = 0;

    O_LOGICPROC_OUT                    = 0;

    O_WAVEWRAP_OUT                     = 0;

    O_NOTEQUANT_OUT                    = 0;

    O_ONOFF_OUT                        = 0;

    O_CLKDIVFIX_16                     = 0;
    O_CLKDIVFIX_T8                     = 1;
    O_CLKDIVFIX_8                      = 2;

    O_DELAY_2_65_MS_FIXED_DELAY        = 0;
    O_DELAY_VARIABLE_DELAY_OUT         = 1;

    O_FOUR_ONESWITCH_OUT               = 0;

    O_LFOSLVA_OUT                      = 0;

    O_AMPLIFIER_OUT                    = 0;

    O_DIODE_OUT                        = 0;

    O_SHAPER_OUT                       = 0;

    O_AD_ENV_ENVELOPE                  = 0;
    O_AD_ENV_OUT                       = 1;

    O_OSCSLVFM_OUT                     = 0;

    O_FILTERA_OUT                      = 0;

    O_FILTERB_OUT                      = 0;

    O_ONE_FOURSWITCH_OUT_1             = 0;
    O_ONE_FOURSWITCH_OUT_2             = 1;
    O_ONE_FOURSWITCH_OUT_3             = 2;
    O_ONE_FOURSWITCH_OUT_4             = 3;

    O_COMPAREAB_A_LARGER_OR_EQUAL_TO_B = 0;

    O_NOTESEQB_OUT                     = 0;
    O_NOTESEQB_SYNC                    = 1;
    O_NOTESEQB_LINK                    = 2;
    O_NOTESEQB_GCLK                    = 3;

    O_CTRLSEQ_OUT                      = 0;
    O_CTRLSEQ_SYNC                     = 1;
    O_CTRLSEQ_LINK                     = 2;

    O_FILTERF_OUT                      = 0;

    O_STEREOCHORUS_OUTLEFT             = 0;
    O_STEREOCHORUS_OUTRIGHT            = 1;

    O_PERCOSC_OUT                      = 0;

    O_FORMANTOSC_OUT                   = 0;
    O_FORMANTOSC_SLAVE                 = 1;

    O_MASTEROSC_SLAVE                  = 0;

    O_KEYQUANT_OUT                     = 0;

    O_PATTERNGEN_OUT                   = 0;

    O_KEYBSPLIT_NOTE                   = 0;
    O_KEYBSPLIT_GATE                   = 1;
    O_KEYBSPLIT_VEL                    = 2;

    O_PHASER_OUT                       = 0;

    O_EQMID_OUT                        = 0;

    O_EQSHELVING_OUT                   = 0;

    O_EXPANDER_OUT_LEFT                = 0;
    O_EXPANDER_OUT_RIGHT               = 1;

    O_OSCSINEBANK_OUT                  = 0;

    O_SPECTRALOSC_OUT                  = 0;
    O_SPECTRALOSC_SLAVE                = 1;

    O_VOCODER_OUT                      = 0;

    O_RANDOMGEN_OUT                    = 0;

    O_LEVMULT_OUT                      = 0;

    O_LEVADD_OUT                       = 0;

    O_ONETOTWOFADE_OUT_1               = 0;
    O_ONETOTWOFADE_OUT_2               = 1;

    O_TWOTOONEFADE_OUT                 = 0;

    O_NOTEVELSCAL_OUT                  = 0;

    O_RINGMOD_OUT                      = 0;

    O_DIGITIZER_OUT                    = 0;

    O_POLYAREAIN_LEFT                  = 0;
    O_POLYAREAIN_RIGHT                 = 1;


  // Custom indices

    C_OSCA_FREQ_DISPLAY_UNITS        = 0;

    C_OSCB_FREQ_DISPLAY_UNITS        = 0;

    C_OSCC_FREQ_DISPLAY_UNITS        = 0;

    C_OSCSLVB_FREQ_DISPLAY_UNITS     = 0;

    C_OSCSLVC_FREQ_DISPLAY_UNITS     = 0;

    C_OSCSLVD_FREQ_DISPLAY_UNITS     = 0;

    C_OSCSLVE_FREQ_DISPLAY_UNITS     = 0;

    C_OSCSLVA_FREQ_DISPLAY_UNITS     = 0;

    C_LFOSLVB_FREQ_DISPLAY_UNITS     = 0;

    C_LFOSLVC_FREQ_DISPLAY_UNITS     = 0;

    C_LFOSLVD_FREQ_DISPLAY_UNITS     = 0;

    C_LFOSLVE_FREQ_DISPLAY_UNITS     = 0;

    C_RNDSTEPGEN_FREQ_DISPLAY_UNITS  = 0;

    C_FILTERD_FREQ_DISPLAY_UNITS     = 0;

    C_FILTERC_FREQ_DISPLAY_UNITS     = 0;

    C_FILTERE_FREQ_DISPLAY_UNITS     = 0;

    C_LFOSLVA_FREQ_DISPLAY_UNITS     = 0;

    C_OSCSLVFM_FREQ_DISPLAY_UNITS    = 0;

    C_NOTESEQB_ZOOMFACTOR            = 0;
    C_NOTESEQB_SLIDERPOSITION        = 1;

    C_FILTERF_FREQ_DISPLAY_UNITS     = 0;

    C_PERCOSC_FREQ_DISPLAY_UNITS     = 0;

    C_FORMANTOSC_FREQ_DISPLAY_UNITS  = 0;

    C_MASTEROSC_FREQ_DISPLAY_UNITS   = 0;

    C_SPECTRALOSC_FREQ_DISPLAY_UNITS = 0;

    C_RANDOMGEN_FREQ_DISPLAY_UNITS   = 0;


  // Knob Id codes (physiacl knob Id's)

    K_KNOB1      =  0;
    K_KNOB2      =  1;
    K_KNOB3      =  2;
    K_KNOB4      =  3;
    K_KNOB5      =  4;
    K_KNOB6      =  5;
    K_KNOB7      =  6;
    K_KNOB8      =  7;
    K_KNOB9      =  8;
    K_KNOB10     =  9;
    K_KNOB11     = 10;
    K_KNOB12     = 11;
    K_KNOB13     = 12;
    K_KNOB14     = 13;
    K_KNOB15     = 14;
    K_KNOB16     = 15;
    K_KNOB17     = 16;
    K_KNOB18     = 17;
    K_PEDAL      = 19;
    K_AFTERTOUCH = 20;
    K_SWITCH     = 22;



Implementation

End.
