
// lexical analyzer template (TP Lex V3.0), V1.0 3-2-91 AG

// global definitions:


//  ////////////////////////////////////////////////////////////////////////////
//
//  Protocol Definition Language
//  Copyright (C) 2003 Marcus Andersson
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//  ////////////////////////////////////////////////////////////////////////////
//
//  Modified to be used in Delphi 7 by Jan Punter.
//
//  Modifications CopyRight (c) 2003 Jan Punter
//
//  Distributed under the same conditions as the original code by Narcus
//  Andersson.
//
//  Notes :
//
//   This is different from how the C versions of Lex and Yacc work.
//   This file is meant to be translated into a pascal file to be included
//   in the code generated from pdlparse.y, no stand alone unit is therefore
//   generated here.
//
//   Some initialization stuff was removed from here as it was already
//   supported by either lexlib.pas, yylex.cod or yyparse.cod.
//
//   This should be compileable for the tp lex vession 3.0 as taken from
//   the free pascal distribution. Modified versions of lexlib.pas, yyylex.cod
//   and yyparse.cod were used. These should be present in this distribution.
//
//    The word END was used as a terminal token, this had to be changed as
//    END is a reserved word in Pascal. I changed it into _END.
//
//    lupd : 2003-10-13
//
//  ////////////////////////////////////////////////////////////////////////////





Function TParser.GetToken: Integer;

  Procedure yyaction( yyruleno: Integer);
  // local definitions:



  Begin
    // actions:
    Case yyruleno Of

  1:
             
    Begin
      // 0x"[0-9a-f]
      yylval := '$' + Copy( yyText, 3, Length( yyText) - 2);
      yyDebugOutFmt( 'NUMBER %s', [ yylval]);
      return( NUMBER);
    End;

  2:
      
    Begin
      // [0-9]*
      yylval := yytext;
      yyDebugOutFmt( 'NUMBER %s', [ yylval]);
      return( NUMBER);
    End;

  3:
                    
    Begin
      // [a-zA-Z][a-zA-Z0-9]*
      yylval := yyText;
      yyDebugOutFmt( 'IDENTIFIER %s', [ yylval]);
      return( IDENTIFIER);
    End;

  4:
 
    Begin
      // %
      yyDebugOut( 'PAD %');
      return( PAD);
    End;

  5:
    
    Begin
      // :=
      yyDebugOut( 'ASSIGN :=');
      return( ASSIGN);
    End;

  6:
    
    Begin
      // =>
      yyDebugOut( 'CHOOSE =>');
      return( CHOOSE);
    End;

  7:
  
    Begin
      // *
      yyDebugOut( 'TIMES *');
      return( TIMES);
    End;

  8:
  
    Begin
      // /
      yyDebugOut( 'STOP /');
      return( STOP);
    End;

  9:
 
    Begin
      // =
      yyDebugOut( 'COMPARE =');
      return( COMPARE);
    End;

  10:
 
    Begin
      // !
      yyDebugOut( 'NOT_COMPARE !');
      return( NOT_COMPARE);
    End;

  11:
  
    Begin
      // $
      yyDebugOut( 'BIND $');
      return( BIND);
    End;

  12:
 
    Begin
      // :
      yyDebugOut( 'SIZE :');
      return( SIZE);
    End;

  13:
  
    Begin
      // ;
      yyDebugOut( '_END ;');
      return( _END);
    End;

  14:
  
    Begin
      // ?
      yyDebugOut( 'OPTIONAL ?');
      return( OPTIONAL);
    End;

  15:
 
    Begin
      // #
      yyDebugOut( 'CONDITIONAL #');
      return( CONDITIONAL);
    End;

  16:
      
    Begin
      // [ \t]+
    End;

  17:
  
    Begin
      // \n
    End;

  18:
       
    Begin
      // // comment to end of line
    End;

  19:
               
    Begin
      // { Comment }
    End;

  20:
                 
    Begin
      // /* Comment */
    End;

  21:
    // We should handle all input.


    End;
  End; // yyaction;

// DFA table:


type YYTRec = record
                cc : set of Char;
                s  : Integer;
              end;

const

yynmarks   = 42;
yynmatches = 42;
yyntrans   = 69;
yynstates  = 34;

yyk : array [1..yynmarks] of Integer = (
  { 0: }
  2,
  { 1: }
  2,
  { 2: }
  2,
  21,
  { 3: }
  2,
  21,
  { 4: }
  3,
  21,
  { 5: }
  4,
  21,
  { 6: }
  12,
  21,
  { 7: }
  9,
  21,
  { 8: }
  7,
  21,
  { 9: }
  8,
  21,
  { 10: }
  10,
  21,
  { 11: }
  11,
  21,
  { 12: }
  13,
  21,
  { 13: }
  14,
  21,
  { 14: }
  15,
  21,
  { 15: }
  16,
  21,
  { 16: }
  17,
  { 17: }
  21,
  { 18: }
  21,
  { 19: }
  1,
  { 20: }
  2,
  { 21: }
  3,
  { 22: }
  5,
  { 23: }
  6,
  { 24: }
  18,
  { 25: }
  { 26: }
  16,
  { 27: }
  { 28: }
  { 29: }
  19,
  { 30: }
  { 31: }
  { 32: }
  { 33: }
  20
);

yym : array [1..yynmatches] of Integer = (
{ 0: }
  2,
{ 1: }
  2,
{ 2: }
  2,
  21,
{ 3: }
  2,
  21,
{ 4: }
  3,
  21,
{ 5: }
  4,
  21,
{ 6: }
  12,
  21,
{ 7: }
  9,
  21,
{ 8: }
  7,
  21,
{ 9: }
  8,
  21,
{ 10: }
  10,
  21,
{ 11: }
  11,
  21,
{ 12: }
  13,
  21,
{ 13: }
  14,
  21,
{ 14: }
  15,
  21,
{ 15: }
  16,
  21,
{ 16: }
  17,
{ 17: }
  21,
{ 18: }
  21,
{ 19: }
  1,
{ 20: }
  2,
{ 21: }
  3,
{ 22: }
  5,
{ 23: }
  6,
{ 24: }
{ 25: }
{ 26: }
  16,
{ 27: }
{ 28: }
{ 29: }
  19,
{ 30: }
  18,
{ 31: }
{ 32: }
{ 33: }
  20
);

yyt : array [1..yyntrans] of YYTrec = (
{ 0: }
  ( cc: [ #1..#8,#11..#31,'"','&'..')','+'..'.','<',
            '>','@','['..'`','|'..#255 ]; s: 18),
  ( cc: [ #9,' ' ]; s: 15),
  ( cc: [ #10 ]; s: 16),
  ( cc: [ '!' ]; s: 10),
  ( cc: [ '#' ]; s: 14),
  ( cc: [ '$' ]; s: 11),
  ( cc: [ '%' ]; s: 5),
  ( cc: [ '*' ]; s: 8),
  ( cc: [ '/' ]; s: 9),
  ( cc: [ '0' ]; s: 2),
  ( cc: [ '1'..'9' ]; s: 3),
  ( cc: [ ':' ]; s: 6),
  ( cc: [ ';' ]; s: 12),
  ( cc: [ '=' ]; s: 7),
  ( cc: [ '?' ]; s: 13),
  ( cc: [ 'A'..'Z','a'..'z' ]; s: 4),
  ( cc: [ '{' ]; s: 17),
{ 1: }
  ( cc: [ #1..#8,#11..#31,'"','&'..')','+'..'.','<',
            '>','@','['..'`','|'..#255 ]; s: 18),
  ( cc: [ #9,' ' ]; s: 15),
  ( cc: [ #10 ]; s: 16),
  ( cc: [ '!' ]; s: 10),
  ( cc: [ '#' ]; s: 14),
  ( cc: [ '$' ]; s: 11),
  ( cc: [ '%' ]; s: 5),
  ( cc: [ '*' ]; s: 8),
  ( cc: [ '/' ]; s: 9),
  ( cc: [ '0' ]; s: 2),
  ( cc: [ '1'..'9' ]; s: 3),
  ( cc: [ ':' ]; s: 6),
  ( cc: [ ';' ]; s: 12),
  ( cc: [ '=' ]; s: 7),
  ( cc: [ '?' ]; s: 13),
  ( cc: [ 'A'..'Z','a'..'z' ]; s: 4),
  ( cc: [ '{' ]; s: 17),
{ 2: }
  ( cc: [ '0'..'9' ]; s: 20),
  ( cc: [ 'x' ]; s: 19),
{ 3: }
  ( cc: [ '0'..'9' ]; s: 20),
{ 4: }
  ( cc: [ '0'..'9','A'..'Z','a'..'z' ]; s: 21),
{ 5: }
{ 6: }
  ( cc: [ '=' ]; s: 22),
{ 7: }
  ( cc: [ '>' ]; s: 23),
{ 8: }
{ 9: }
  ( cc: [ '*' ]; s: 25),
  ( cc: [ '/' ]; s: 24),
{ 10: }
{ 11: }
{ 12: }
{ 13: }
{ 14: }
{ 15: }
  ( cc: [ #9,' ' ]; s: 26),
{ 16: }
{ 17: }
  ( cc: [ #1..#9,#11..'|','~'..#255 ]; s: 27),
  ( cc: [ #10 ]; s: 28),
  ( cc: [ '}' ]; s: 29),
{ 18: }
{ 19: }
  ( cc: [ '0'..'9','a'..'f' ]; s: 19),
{ 20: }
  ( cc: [ '0'..'9' ]; s: 20),
{ 21: }
  ( cc: [ '0'..'9','A'..'Z','a'..'z' ]; s: 21),
{ 22: }
{ 23: }
{ 24: }
  ( cc: [ #1..#9,#11..#255 ]; s: 24),
  ( cc: [ #10 ]; s: 30),
{ 25: }
  ( cc: [ #1..#9,#11..')','+'..#255 ]; s: 31),
  ( cc: [ #10 ]; s: 25),
  ( cc: [ '*' ]; s: 32),
{ 26: }
  ( cc: [ #9,' ' ]; s: 26),
{ 27: }
  ( cc: [ #1..#9,#11..#255 ]; s: 27),
  ( cc: [ #10 ]; s: 28),
{ 28: }
  ( cc: [ #1..#9,#11..'|','~'..#255 ]; s: 27),
  ( cc: [ #10 ]; s: 28),
  ( cc: [ '}' ]; s: 29),
{ 29: }
  ( cc: [ #1..#9,#11..#255 ]; s: 27),
  ( cc: [ #10 ]; s: 28),
{ 30: }
{ 31: }
  ( cc: [ #1..#9,#11..#255 ]; s: 31),
  ( cc: [ #10 ]; s: 25),
{ 32: }
  ( cc: [ #1..#9,#11..'.','0'..#255 ]; s: 31),
  ( cc: [ #10 ]; s: 25),
  ( cc: [ '/' ]; s: 33),
{ 33: }
  ( cc: [ #1..#9,#11..#255 ]; s: 31),
  ( cc: [ #10 ]; s: 25)
);

yykl : array [0..yynstates-1] of Integer = (
{ 0: } 1,
{ 1: } 2,
{ 2: } 3,
{ 3: } 5,
{ 4: } 7,
{ 5: } 9,
{ 6: } 11,
{ 7: } 13,
{ 8: } 15,
{ 9: } 17,
{ 10: } 19,
{ 11: } 21,
{ 12: } 23,
{ 13: } 25,
{ 14: } 27,
{ 15: } 29,
{ 16: } 31,
{ 17: } 32,
{ 18: } 33,
{ 19: } 34,
{ 20: } 35,
{ 21: } 36,
{ 22: } 37,
{ 23: } 38,
{ 24: } 39,
{ 25: } 40,
{ 26: } 40,
{ 27: } 41,
{ 28: } 41,
{ 29: } 41,
{ 30: } 42,
{ 31: } 42,
{ 32: } 42,
{ 33: } 42
);

yykh : array [0..yynstates-1] of Integer = (
{ 0: } 1,
{ 1: } 2,
{ 2: } 4,
{ 3: } 6,
{ 4: } 8,
{ 5: } 10,
{ 6: } 12,
{ 7: } 14,
{ 8: } 16,
{ 9: } 18,
{ 10: } 20,
{ 11: } 22,
{ 12: } 24,
{ 13: } 26,
{ 14: } 28,
{ 15: } 30,
{ 16: } 31,
{ 17: } 32,
{ 18: } 33,
{ 19: } 34,
{ 20: } 35,
{ 21: } 36,
{ 22: } 37,
{ 23: } 38,
{ 24: } 39,
{ 25: } 39,
{ 26: } 40,
{ 27: } 40,
{ 28: } 40,
{ 29: } 41,
{ 30: } 41,
{ 31: } 41,
{ 32: } 41,
{ 33: } 42
);

yyml : array [0..yynstates-1] of Integer = (
{ 0: } 1,
{ 1: } 2,
{ 2: } 3,
{ 3: } 5,
{ 4: } 7,
{ 5: } 9,
{ 6: } 11,
{ 7: } 13,
{ 8: } 15,
{ 9: } 17,
{ 10: } 19,
{ 11: } 21,
{ 12: } 23,
{ 13: } 25,
{ 14: } 27,
{ 15: } 29,
{ 16: } 31,
{ 17: } 32,
{ 18: } 33,
{ 19: } 34,
{ 20: } 35,
{ 21: } 36,
{ 22: } 37,
{ 23: } 38,
{ 24: } 39,
{ 25: } 39,
{ 26: } 39,
{ 27: } 40,
{ 28: } 40,
{ 29: } 40,
{ 30: } 41,
{ 31: } 42,
{ 32: } 42,
{ 33: } 42
);

yymh : array [0..yynstates-1] of Integer = (
{ 0: } 1,
{ 1: } 2,
{ 2: } 4,
{ 3: } 6,
{ 4: } 8,
{ 5: } 10,
{ 6: } 12,
{ 7: } 14,
{ 8: } 16,
{ 9: } 18,
{ 10: } 20,
{ 11: } 22,
{ 12: } 24,
{ 13: } 26,
{ 14: } 28,
{ 15: } 30,
{ 16: } 31,
{ 17: } 32,
{ 18: } 33,
{ 19: } 34,
{ 20: } 35,
{ 21: } 36,
{ 22: } 37,
{ 23: } 38,
{ 24: } 38,
{ 25: } 38,
{ 26: } 39,
{ 27: } 39,
{ 28: } 39,
{ 29: } 40,
{ 30: } 41,
{ 31: } 41,
{ 32: } 41,
{ 33: } 42
);

yytl : array [0..yynstates-1] of Integer = (
{ 0: } 1,
{ 1: } 18,
{ 2: } 35,
{ 3: } 37,
{ 4: } 38,
{ 5: } 39,
{ 6: } 39,
{ 7: } 40,
{ 8: } 41,
{ 9: } 41,
{ 10: } 43,
{ 11: } 43,
{ 12: } 43,
{ 13: } 43,
{ 14: } 43,
{ 15: } 43,
{ 16: } 44,
{ 17: } 44,
{ 18: } 47,
{ 19: } 47,
{ 20: } 48,
{ 21: } 49,
{ 22: } 50,
{ 23: } 50,
{ 24: } 50,
{ 25: } 52,
{ 26: } 55,
{ 27: } 56,
{ 28: } 58,
{ 29: } 61,
{ 30: } 63,
{ 31: } 63,
{ 32: } 65,
{ 33: } 68
);

yyth : array [0..yynstates-1] of Integer = (
{ 0: } 17,
{ 1: } 34,
{ 2: } 36,
{ 3: } 37,
{ 4: } 38,
{ 5: } 38,
{ 6: } 39,
{ 7: } 40,
{ 8: } 40,
{ 9: } 42,
{ 10: } 42,
{ 11: } 42,
{ 12: } 42,
{ 13: } 42,
{ 14: } 42,
{ 15: } 43,
{ 16: } 43,
{ 17: } 46,
{ 18: } 46,
{ 19: } 47,
{ 20: } 48,
{ 21: } 49,
{ 22: } 49,
{ 23: } 49,
{ 24: } 51,
{ 25: } 54,
{ 26: } 55,
{ 27: } 57,
{ 28: } 60,
{ 29: } 62,
{ 30: } 62,
{ 31: } 64,
{ 32: } 67,
{ 33: } 69
);


  Var

    yyn : Integer;

  Label

    start,
    scan,
    action;

  Begin

  start:

    yynew; // initialize:

  scan:

    // mark positions and matches:

    For yyn := yykl[ yystate] To yykh[ yystate] Do
      yymark( yyk[ yyn]);

    For yyn := yymh[ yystate] Downto yyml[ yystate] Do
      yymatch( yym[ yyn]);

    If yytl[ yystate] > yyth[ yystate]
    Then Goto action; // dead state

    // get next character:

    yyscan;

    // determine action:

    yyn := yytl[ yystate];
    While ( yyn <= yyth[ yystate]) And Not ( yyactchar in yyt[ yyn].cc) Do
      Inc( yyn);
    If yyn > yyth[ yystate]
    Then Goto action; // no transition on yyactchar in this state

    // switch to new state:

    yystate := yyt[ yyn].s;

    Goto scan;

  action:

    // execute action:

    If yyfind(yyrule)
    Then Begin
      yyaction( yyrule);
      If yyreject
      Then Goto action;
    End
    Else
      If Not yydefault And yywrap
      Then
      Begin
        yyclear;
        return( 0);
      End;

    If Not yydone
    Then Goto start;

    Result := yyretval;

End; // yylex





